/*
 * Copyright 2018 Qunar, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package qunar.tc.qmq.meta.web;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * @author keli.wang
 * @since 2018-11-27
 */
public class JsonResult<T> {
    public final int status;
    public final String message;
    public final T data;

    @JsonCreator
    public JsonResult(@JsonProperty("status") int status,
                      @JsonProperty("message") String message,
                      @JsonProperty("data") T data) {
        this.status = status;
        this.message = message;
        this.data = data;
    }
}
